## avidemux 2.5.3

=== CMakeLists.txt ===
MESSAGE("#####################################")
MESSAGE("Configure Started")
MESSAGE("#####################################")
MESSAGE("")

CMAKE_MINIMUM_REQUIRED(VERSION 2.6.2 FATAL_ERROR)

if (COMMAND cmake_policy)
	cmake_policy(SET CMP0004 OLD)
endif (COMMAND cmake_policy)

SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

IF (NOT CMAKE_CXX_COMPILER_WORKS MATCHES "^${CMAKE_CXX_COMPILER_WORKS}$")
	SET(FRESH_BUILD 1)
ENDIF (NOT CMAKE_CXX_COMPILER_WORKS MATCHES "^${CMAKE_CXX_COMPILER_WORKS}$")

# need for shared cmake script between avidemux & plugins
SET(AVIDEMUX_SOURCE_DIR ${CMAKE_SOURCE_DIR})
MESSAGE(STATUS "Source dir is ${AVIDEMUX_SOURCE_DIR}")
MESSAGE("")

PROJECT(Avidemux)

IF (${Avidemux_SOURCE_DIR} MATCHES ${Avidemux_BINARY_DIR})
	MESSAGE("Please do an out-of-tree build:")
	MESSAGE("rm CMakeCache.txt; mkdir build; cd build; cmake ..; make")
	MESSAGE(FATAL_ERROR "in-tree-build detected")
ENDIF (${Avidemux_SOURCE_DIR} MATCHES ${Avidemux_BINARY_DIR})

INCLUDE(admConfigHelper)

IF (FRESH_BUILD)
	MESSAGE("")
ENDIF (FRESH_BUILD)

########################################
# Global options
########################################
OPTION(VERBOSE "" OFF)

IF (NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE "Release")
ENDIF (NOT CMAKE_BUILD_TYPE)

########################################
# Avidemux system specific tweaks
########################################
INCLUDE(admDetermineSystem)

IF (CYGWIN)
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mwin32")
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mwin32")
ENDIF (CYGWIN)

IF (ADM_CPU_ALTIVEC)
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${ADM_ALTIVEC_FLAGS}")
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${ADM_ALTIVEC_FLAGS}")
ENDIF (ADM_CPU_ALTIVEC)

IF (UNIX AND NOT APPLE)
	# jog shuttle is only available on Linux due to its interface
	SET(USE_JOG 1)
ENDIF (UNIX AND NOT APPLE)

IF (WIN32)
	SET(BIN_DIR .)
	SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-enable-auto-image-base -Wl,-enable-auto-import")
	SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-enable-auto-import")

	IF (CMAKE_BUILD_TYPE STREQUAL "Release")
		SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-s")
		SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-s")
	ENDIF (CMAKE_BUILD_TYPE STREQUAL "Release")
ELSE (WIN32)
	SET(BIN_DIR bin)
ENDIF (WIN32)

IF (APPLE)
	## Add needed Compiler and Linker flags for OSX
	SET(CMAKE_C_FLAGS:STRING "\"$CMAKE_C_FLAGS\" -flat_namespace -undefined suppress" )
	SET(CMAKE_CXX_FLAGS:STRING "\"$CMAKE_CXX_FLAGS\" -flat_namespace -undefined suppress" )
	SET(CMAKE_LDFLAGS:STRING "\"$CMAKE_LD_FLAGS\"" )
	SET(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib" )

	IF (${CMAKE_BUILD_TYPE} STREQUAL "Release")
		SET(CMAKE_C_FLAGS_RELEASE:STRING " $CMAKE_C_FLAGS_RELEASE ")
		SET(CMAKE_CXX_FLAGS_RELEASE:STRING " $CMAKE_CXX_FLAGS_RELEASE ")
	ENDIF (${CMAKE_BUILD_TYPE} STREQUAL "Release")

	if (${MAC_SELF_CONTAINED_BUNDLE})
		MESSAGE(STATUS "Configuring avidemux for fully bundled version. (not yet working correctly)")
		SET(CMAKE_INSTALL_NAME_DIR "@executable_path/../Libraries" )
	endif (${MAC_SELF_CONTAINED_BUNDLE})
ENDIF (APPLE)

########################################
# Standard Avidemux defines
########################################
SET(VERSION 2.5.3)

# Define internal flags for GTK+ and Qt4 builds.  These are turned off
# if a showstopper is found.  CLI is automatically assumed as possible
# since it uses the minimum set of required libraries and CMake will 
# fail if these aren't met.
SET(ADM_UI_GTK 1)
SET(ADM_UI_QT4 1)

SET(ADM_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}")

IF (CMAKE_BUILD_TYPE STREQUAL "Debug")
	SET(ADM_DEBUG 1)
ENDIF (CMAKE_BUILD_TYPE STREQUAL "Debug")

########################################
# Subversion
########################################
OPTION(SVN "" ON)
SET(ADM_SUBVERSION 0)


########################################
# Check for libraries
########################################
SET(MSG_DISABLE_OPTION "Disabled per request")

INCLUDE(admCheckRequiredLibs)
INCLUDE(admCheckGtk)
INCLUDE(admCheckQt4)

checkGtk()
checkQt4()

#INCLUDE(admCheckAudioCodecLibs)
#INCLUDE(admCheckAudioDeviceLibs)
INCLUDE(admCheckMiscLibs)

########################################
# Check functions and includes
########################################
IF (NOT SYSTEM_HEADERS_CHECKED)
	MESSAGE(STATUS "Checking system headers")
	MESSAGE(STATUS "***********************")

	INCLUDE(CheckIncludeFiles)
	INCLUDE(CheckFunctionExists)

	CHECK_FUNCTION_EXISTS(gettimeofday HAVE_GETTIMEOFDAY)

	CHECK_INCLUDE_FILES(inttypes.h   HAVE_INTTYPES_H)	# internal use, mpeg2enc, mplex
	CHECK_INCLUDE_FILES(stdint.h     HAVE_STDINT_H)		# internal use, mpeg2enc, mplex
	CHECK_INCLUDE_FILES(sys/types.h  HAVE_SYS_TYPES_H)	# mad, mpeg2enc
	CHECK_INCLUDE_FILES(malloc.h     HAVE_MALLOC_H)		# mplex
	SET(SYSTEM_HEADERS_CHECKED 1 CACHE BOOL "")
	MARK_AS_ADVANCED(SYSTEM_HEADERS_CHECKED)

	MESSAGE("")
ENDIF (NOT SYSTEM_HEADERS_CHECKED)

########################################
# Debug Summary
########################################
IF (VERBOSE)
	INCLUDE(adm_log)
	MESSAGE("")
ENDIF (VERBOSE)

########################################
# Generate config.h
########################################
CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/cmake/ADM_coreConfig.h.cmake" "${CMAKE_BINARY_DIR}/config/ADM_coreConfig.h")
MESSAGE(STATUS "ADM_coreConfig.h generated")

SET(CONFIG_HEADER_TYPE ADM_BUILD_CLI)
CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/cmake/config.h.cmake" "${CMAKE_BINARY_DIR}/config/cli/config.h")
MESSAGE(STATUS "CLI config.h generated")

SET(CONFIG_HEADER_TYPE ADM_BUILD_GTK)
CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/cmake/config.h.cmake" "${CMAKE_BINARY_DIR}/config/gtk/config.h")
MESSAGE(STATUS "GTK config.h generated")

SET(CONFIG_HEADER_TYPE ADM_BUILD_QT4)
CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/cmake/config.h.cmake" "${CMAKE_BINARY_DIR}/config/qt4/config.h")
MESSAGE(STATUS "Qt4 config.h generated")

MESSAGE("")

########################################
# Directories to build
########################################
ADD_SUBDIRECTORY(avidemux)
ADD_SUBDIRECTORY(po)
ADD_SUBDIRECTORY(scripts)
# MEANX : DOES NOT WORK ADD_SUBDIRECTORY(plugins EXCLUDE_FROM_ALL)

########################################
# Config Summary
########################################
INCLUDE(admConfigSummary)
MESSAGE("")

=== avidemux/CMakeLists.txt ===
########################################
# Macros
########################################
MACRO (ADD_ADMLIB_ALL_TARGETS)
	FOREACH (_libName ${ARGV})
		TARGET_LINK_LIBRARIES(avidemux2_cli ${_libName}_cli)

		IF (ADM_UI_GTK)
			TARGET_LINK_LIBRARIES(avidemux2_gtk ${_libName}_gtk)
		ENDIF (ADM_UI_GTK)

		IF (ADM_UI_QT4)
			TARGET_LINK_LIBRARIES(avidemux2_qt4 ${_libName}_qt4)
		ENDIF (ADM_UI_QT4)
	ENDFOREACH (_libName ${ARGV})
ENDMACRO (ADD_ADMLIB_ALL_TARGETS)


MACRO (ADD_LIB_ALL_TARGETS)
	TARGET_LINK_LIBRARIES(avidemux2_cli ${ARGV})

	IF (ADM_UI_GTK)
		TARGET_LINK_LIBRARIES(avidemux2_gtk ${ARGV})
	ENDIF (ADM_UI_GTK)

	IF (ADM_UI_QT4)
		TARGET_LINK_LIBRARIES(avidemux2_qt4 ${ARGV})
	ENDIF (ADM_UI_QT4)
ENDMACRO (ADD_LIB_ALL_TARGETS)


MACRO (ADD_LDFLAGS_ALL_TARGETS)
	ADD_TARGET_LDFLAGS(avidemux2_cli ${ARGV})

	IF (ADM_UI_GTK)
		ADD_TARGET_LDFLAGS(avidemux2_gtk ${ARGV})
	ENDIF (ADM_UI_GTK)

	IF (ADM_UI_QT4)
		ADD_TARGET_LDFLAGS(avidemux2_qt4 ${ARGV})
	ENDIF (ADM_UI_QT4)
ENDMACRO (ADD_LDFLAGS_ALL_TARGETS)

########################################
# Functions
########################################
function(MakeOSXBundleApp target binary_dir)
	SET (OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT "${binary_dir}/${target}_OSX_MakeStandAloneBundle.cmake")
	SET (OSX_MAKE_STANDALONE_BUNDLE_BASH_SCRIPT "${binary_dir}/${target}_OSX_MakeStandAloneBundle.sh")

	#-- Configure the cmake file and the shell script
	CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/../cmake/Apple/CompleteBundle.cmake.in"
		"${OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT}" @ONLY IMMEDIATE)
	CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/../cmake/Apple/CreateBundle.sh.in"
		"${OSX_MAKE_STANDALONE_BUNDLE_BASH_SCRIPT}" @ONLY IMMEDIATE)

	#-- Create the installation code
	install(SCRIPT "${OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT}")
endfunction(MakeOSXBundleApp)

########################################
# Definitions and Includes
########################################
ADD_DEFINITIONS(-D_FILE_OFFSET_BITS=64 -D_LARGE_FILES)
ADD_DEFINITIONS(-DHAVE_CONFIG_H)

IF (ADM_DEBUG)
	ADD_DEFINITIONS(-DADM_DEBUG)
ENDIF (ADM_DEBUG)

INCLUDE_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}")
INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}/config")
INCLUDE_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}/ADM_core/include")
INCLUDE_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}/ADM_coreUI/include")
INCLUDE_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}/ADM_coreImage/include")
INCLUDE_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}/ADM_coreAudio/include")
INCLUDE_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}/ADM_libraries/ADM_utilities")

IF (GETTEXT_FOUND)
	INCLUDE_DIRECTORIES(${GETTEXT_INCLUDE_DIR})
ENDIF (GETTEXT_FOUND)

########################################
# Embed resources for executables
########################################
IF (APPLE)
	# add icon
	SET(ADM_EXE_SRCS ${ADM_EXE_SRCS} ${CMAKE_CURRENT_SOURCE_DIR}/ADM_icons/xpm/avidemux.icns)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/ADM_icons/xpm/avidemux.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

	# bundle version info
	SET(ADM_OSX_VERSION "${VERSION}")

	IF (Subversion_FOUND)
		SET(ADM_OSX_VERSION "${ADM_OSX_VERSION} (r${ADM_SUBVERSION})")
	ENDIF (Subversion_FOUND)

	SET(MACOSX_BUNDLE_ICON_FILE avidemux.icns)
	SET(MACOSX_BUNDLE_INFO_STRING "Avidemux ${ADM_OSX_VERSION}")
	SET(MACOSX_BUNDLE_LONG_VERSION_STRING "${ADM_OSX_VERSION}") 
	SET(MACOSX_BUNDLE_SHORT_VERSION_STRING "${ADM_OSX_VERSION}")
	SET(MACOSX_BUNDLE_VERSION "${ADM_OSX_VERSION}")
	SET(MACOSX_BUNDLE_BUNDLE_NAME "Avidemux" )
	SET(MACOSX_BUNDLE_COPYRIGHT "Copyright 2001-2010 Mean" )
	SET(MACOSX_BUNDLE_SIGNATURE "Avdx" )
	SET(MACOSX_BUNDLE_GUI_IDENTIFIER www.avidemux.org)

	# include translation files in bundle
	# this isn't the cleanest approach but there's not much we can do until the po directory is under the avidemux directory
	FILE(GLOB PO_FILES ${CMAKE_SOURCE_DIR}/po/*.po)

	FOREACH(_file ${PO_FILES})
		GET_FILENAME_COMPONENT(_filename ${_file} NAME_WE)
		SET(_mofile "${CMAKE_BINARY_DIR}/po/${_filename}/avidemux.mo")

		SET(MO_FILES ${MO_FILES} ${_mofile})
		SET_SOURCE_FILES_PROPERTIES(${_mofile} PROPERTIES GENERATED TRUE MACOSX_PACKAGE_LOCATION "Resources/locale/${_filename}/LC_MESSAGES")
	ENDFOREACH(_file)

	FILE(GLOB TS_FILES ${CMAKE_SOURCE_DIR}/po/*.ts)

	FOREACH(_file ${TS_FILES})
		GET_FILENAME_COMPONENT(_filename ${_file} NAME_WE)
		SET(_qmfile "${CMAKE_BINARY_DIR}/po/${_filename}.qm")

		SET(QM_FILES ${QM_FILES} ${_qmfile})
		SET_SOURCE_FILES_PROPERTIES(${_qmfile} PROPERTIES GENERATED TRUE MACOSX_PACKAGE_LOCATION "Resources/locale")
	ENDFOREACH(_file)
ENDIF (APPLE)

IF (WIN32)
	# add icon and version info
	SET(FILEVERSION_STRING "${VERSION}.${ADM_SUBVERSION}")
	SET(PRODUCTVERSION_STRING "${VERSION}")
	STRING(REPLACE "." "," FILEVERSION ${FILEVERSION_STRING})
	STRING(REPLACE "." "," PRODUCTVERSION ${PRODUCTVERSION_STRING})
	SET(PRODUCTVERSION "${PRODUCTVERSION},0")

	SET(AVIDEMUX_ICON "adm.ico")
	SET(WIN_RES_GTK "admWinGtk.obj")
	CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/cmake/admWin32.rc.in" ${CMAKE_CURRENT_BINARY_DIR}/admWinGtk.rc IMMEDIATE)
	ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${WIN_RES_GTK} COMMAND windres.exe -i ${CMAKE_CURRENT_BINARY_DIR}/admWinGtk.rc -o ${CMAKE_CURRENT_BINARY_DIR}/${WIN_RES_GTK} -O coff --define VS_VERSION_INFO=1)

	SET(AVIDEMUX_ICON "avidemux.ico")
	SET(WIN_RES_QT "admWinQt.obj")
	CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/cmake/admWin32.rc.in" ${CMAKE_CURRENT_BINARY_DIR}/admWinQt.rc IMMEDIATE)
	ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${WIN_RES_QT} COMMAND windres.exe -i ${CMAKE_CURRENT_BINARY_DIR}/admWinQt.rc -o ${CMAKE_CURRENT_BINARY_DIR}/${WIN_RES_QT} -O coff --define VS_VERSION_INFO=1)
ENDIF (WIN32)

########################################
# Our exectuables
########################################
SET(ADM_EXE_SRCS ${ADM_EXE_SRCS} ADM_preview.cpp  gtk_gui.cpp  GUI_jobs.cpp  gui_navigate.cpp  guiplay.cpp  gui_savenew.cpp  main.cpp  gui_action.cpp)

ADD_EXECUTABLE(avidemux2_cli MACOSX_BUNDLE ${ADM_EXE_SRCS} ${MO_FILES} ${WIN_RES_GTK})
ADD_TARGET_CFLAGS(avidemux2_cli "-I${CMAKE_BINARY_DIR}/config/cli")
ADD_DEPENDENCIES(avidemux2_cli mofiles  ffmpeg)

IF (ADM_UI_GTK)
	ADD_EXECUTABLE(avidemux2_gtk MACOSX_BUNDLE ${ADM_EXE_SRCS} ${MO_FILES} ${WIN_RES_GTK})
	ADD_TARGET_CFLAGS(avidemux2_gtk "-I${CMAKE_BINARY_DIR}/config/gtk")
	ADD_DEPENDENCIES(avidemux2_gtk mofiles  ffmpeg)
ENDIF (ADM_UI_GTK)

IF (ADM_UI_QT4)
	ADD_EXECUTABLE(avidemux2_qt4 MACOSX_BUNDLE ${ADM_EXE_SRCS} ${QM_FILES} ${WIN_RES_QT})
	
	IF (WIN32 OR APPLE)
		set_property(TARGET avidemux2_qt4 PROPERTY OUTPUT_NAME avidemux2)
	ENDIF (WIN32 OR APPLE)
	
	ADD_TARGET_CFLAGS(avidemux2_qt4 "-I${CMAKE_BINARY_DIR}/config/qt4")
	ADD_DEPENDENCIES(avidemux2_qt4 qmfiles  ffmpeg)
ENDIF (ADM_UI_QT4)

SDLify(main.cpp)
ADD_SOURCE_CFLAGS(main.cpp "-DADM_SUBVERSION=${ADM_SUBVERSION} -I${PTHREAD_INCLUDE_DIR}")
ADD_SOURCE_CFLAGS(gui_savenew.cpp "-I${PTHREAD_INCLUDE_DIR}")

########################################
# FFmpeg
########################################
include(admFFmpegBuild)

########################################
# Compile and link general subdirs
########################################
SET(ADM_SUBDIR 
	ADM_audiofilter
	#ADM_audioEncoder
	ADM_editor
	ADM_audiocodec
	ADM_audio
	ADM_script
	ADM_filter
	ADM_videoFilter
	ADM_video
	ADM_audiodevice
	ADM_ocr
)
FOREACH(_current ${ADM_SUBDIR})
	ADD_SUBDIRECTORY(${_current})
	ADD_ADMLIB_ALL_TARGETS(${_current})
ENDFOREACH(_current ${ADM_SUBDIR})

###########################################
# Construct ADM_outputs
###########################################
ADD_SUBDIRECTORY(ADM_outputs)

SET(ADM_OUTPUTS	
	oplug_avi
	oplug_mp4
	oplug_mpeg
	oplug_mpegFF
	oplug_ogm
	oplug_flv
	oplug_dummy
	ADM_outputs)

ADD_ADMLIB_ALL_TARGETS(${ADM_OUTPUTS})

###########################################
# Construct ADM_inputs
###########################################
ADD_SUBDIRECTORY(ADM_inputs)
ADD_SUBDIRECTORY(ADM_UIs)

SET(ADM_INPUTS
	ADM_asf
	ADM_avsproxy
	ADM_h263
	ADM_inpics
	ADM_matroska
	ADM_mp4
	ADM_mpegdemuxer
	ADM_nuv
	ADM_ogm
	ADM_openDML
	ADM_flv
	ADM_amv)

ADD_ADMLIB_ALL_TARGETS(${ADM_INPUTS})

#########################################
# Tails
#########################################
SET(ADM_TAILS
	ADM_osSupport
	ADM_encoder
	ADM_toolkit
	ADM_codecs
	ADM_requant
	ADM_infoExtractor)

FOREACH(_current ${ADM_TAILS})
	ADD_SUBDIRECTORY(${_current})
	ADD_ADMLIB_ALL_TARGETS(${_current})
ENDFOREACH(_current ${ADM_TAILS})
###########################################
# Construct ADM_libraries
###########################################
ADD_SUBDIRECTORY(ADM_libraries)

ADD_ADMLIB_ALL_TARGETS(
	ADM_mplex
	ADM_lvemux
	ADM_utilities
)

ADD_LIB_ALL_TARGETS(
	ADM_libavutil
	ADM_libpostproc
	ADM_libswscale
	ADM_libavcodec
	ADM_libavformat)

if (USE_SYSTEM_SPIDERMONKEY)
	ADD_LIB_ALL_TARGETS(${SPIDERMONKEY_LIBRARY_DIR})
else (USE_SYSTEM_SPIDERMONKEY)
	ADD_LIB_ALL_TARGETS(ADM_smjs)
endif (USE_SYSTEM_SPIDERMONKEY)

IF (ADM_DEBUG AND FIND_LEAKS)
	ADD_ADMLIB_ALL_TARGETS(ADM_nvwa)
ENDIF (ADM_DEBUG AND FIND_LEAKS)

IF (APPLE AND USE_SDL)
	IF (ADM_UI_GTK)
		TARGET_LINK_LIBRARIES(avidemux2_gtk ADM_libsdl_gtk)
	ENDIF (ADM_UI_GTK)

	IF (ADM_UI_QT4)
		TARGET_LINK_LIBRARIES(avidemux2_qt4 ADM_libsdl_qt4)
	ENDIF (ADM_UI_QT4)
ENDIF (APPLE AND USE_SDL)

###########################################
# Construct ADM_userInterface
###########################################
ADD_SUBDIRECTORY(ADM_userInterfaces)

TARGET_LINK_LIBRARIES(avidemux2_cli
	ADM_UI_None_cli
	ADM_commonUI_cli
	ADM_ocr_cli
	ADM_dialogNone_cli
	ADM_dialogFiltersNone_cli
	ADM_dialogGuiNone_cli
	ADM_UICli
	ADM_render_cli
)

IF (ADM_UI_GTK)
	TARGET_LINK_LIBRARIES(avidemux2_gtk
		ADM_UI_GTK_gtk
		ADM_commonUI_gtk
		ADM_ocr_gtk
		ADM_ocrGtk_gtk
		ADM_dialogGtk_gtk
		ADM_filtersGtk_gtk
		ADM_gui2Gtk_gtk
		ADM_commonUI_gtk
		ADM_toolkitGtk_gtk
		ADM_UIGtk
		ADM_render_gtk
	)
ENDIF (ADM_UI_GTK)

IF (ADM_UI_QT4)
	TARGET_LINK_LIBRARIES(avidemux2_qt4
		ADM_UI_QT4_qt4
		ADM_commonUI_qt4
		ADM_ocr_qt4
		ADM_ocrQt4_qt4
		ADM_dialogQt4_qt4
		ADM_guiQt4_qt4
		ADM_filtersQt4_qt4
		ADM_commonUI_qt4
		ADM_dialogQt4_qt4
		ADM_UIQT4
		ADM_render_qt4
	)
ENDIF (ADM_UI_QT4)

ADD_ADMLIB_ALL_TARGETS(ADM_utilities)

###########################################
# ADM_core/ADM_coreUI
###########################################
ADD_SUBDIRECTORY(ADM_core)
ADD_LIB_ALL_TARGETS(ADM_core)
ADD_SUBDIRECTORY(ADM_coreUI)
ADD_LIB_ALL_TARGETS(ADM_coreUI)
ADD_SUBDIRECTORY(ADM_coreImage)
ADD_LIB_ALL_TARGETS(ADM_coreImage)
ADD_SUBDIRECTORY(ADM_coreAudio)
ADD_LIB_ALL_TARGETS(ADM_coreAudio)

# To be removed
#ADD_SUBDIRECTORY(ADM_audioEncoder)

###########################################
# External libs
###########################################
# gettext
IF (GETTEXT_FOUND)
	TARGET_LINK_LIBRARIES(avidemux2_cli ${GETTEXT_LIBRARY_DIR})

	IF (ADM_UI_GTK)
		TARGET_LINK_LIBRARIES(avidemux2_gtk ${GETTEXT_LIBRARY_DIR})
	ENDIF (ADM_UI_GTK)
ENDIF (GETTEXT_FOUND)

# pthreads
IF (UNIX AND PTHREAD_FOUND)
	ADD_LIB_ALL_TARGETS("${PTHREAD_LIBRARIES}")
ENDIF (UNIX AND PTHREAD_FOUND)

# Libxml2
ADD_LIB_ALL_TARGETS("${LIBXML2_LIBRARIES}")

# XVideo
IF (USE_XV)
	IF (ADM_UI_GTK)
		TARGET_LINK_LIBRARIES(avidemux2_gtk ${XVIDEO_LIBRARY_DIR})
	ENDIF (ADM_UI_GTK)

	IF (ADM_UI_QT4)
		TARGET_LINK_LIBRARIES(avidemux2_qt4 ${XVIDEO_LIBRARY_DIR})
	ENDIF (ADM_UI_QT4)
ENDIF (USE_XV)

# SDL
IF (USE_SDL)
	IF (ADM_UI_GTK)
		TARGET_LINK_LIBRARIES(avidemux2_gtk ${SDL_LIBRARY})
	ENDIF (ADM_UI_GTK)

	IF (ADM_UI_QT4)
		TARGET_LINK_LIBRARIES(avidemux2_qt4 ${SDL_LIBRARY})
	ENDIF (ADM_UI_QT4)
ENDIF (USE_SDL)

###########################################
# UI Specific
###########################################
IF (ADM_UI_GTK)
	ADD_TARGET_LDFLAGS(avidemux2_gtk ${GTK_LDFLAGS} ${GTHREAD_LDFLAGS})
ENDIF (ADM_UI_GTK)

IF (ADM_UI_QT4)
	TARGET_LINK_LIBRARIES(avidemux2_qt4 ${QT_QTGUI_LIBRARY} ${QT_QTCORE_LIBRARY})
ENDIF (ADM_UI_QT4)

###########################################
# OS Specific
###########################################
IF (WIN32)
	ADD_ADMLIB_ALL_TARGETS(ADM_osSupport)

=== avidemux/ADM_codecs/CMakeLists.txt ===
SET(ADM_codecs_SRCS 
	ADM_codecs.cpp  ADM_ffmp43.cpp  ADM_uyvy.cpp)

ADD_ADM_LIB_ALL_TARGETS(ADM_codecs ${ADM_codecs_SRCS})
REMOVE_DEFINITIONS(-DHAVE_CONFIG_H)

=== avidemux/ADM_toolkit/CMakeLists.txt ===
SET(ADM_toolkit_SRCS 
	ADM_audioQueue.cpp  ADM_packetQueue.cpp  automation.cpp  filesel.cpp)

include_directories("${PTHREAD_INCLUDE_DIR}")
ADD_ADM_LIB_ALL_TARGETS(ADM_toolkit ${ADM_toolkit_SRCS})

=== libavcodec/arm/Makefile ===
OBJS-$(CONFIG_H264DSP)                 += arm/h264dsp_init_arm.o        \
                                          arm/h264pred_init_arm.o       \

OBJS                                   += arm/dsputil_init_arm.o        \
                                          arm/dsputil_arm.o             \
                                          arm/fft_init_arm.o            \
                                          arm/jrevdct_arm.o             \
                                          arm/mpegvideo_arm.o           \
                                          arm/simple_idct_arm.o         \

OBJS-$(HAVE_ARMV5TE)                   += arm/dsputil_init_armv5te.o    \
                                          arm/mpegvideo_armv5te.o       \
                                          arm/mpegvideo_armv5te_s.o     \
                                          arm/simple_idct_armv5te.o     \

OBJS-$(HAVE_ARMV6)                     += arm/dsputil_init_armv6.o      \
                                          arm/dsputil_armv6.o           \
                                          arm/simple_idct_armv6.o       \

OBJS-$(HAVE_ARMVFP)                    += arm/dsputil_vfp.o             \
                                          arm/dsputil_init_vfp.o        \

OBJS-$(HAVE_IWMMXT)                    += arm/dsputil_iwmmxt.o          \
                                          arm/mpegvideo_iwmmxt.o        \

NEON-OBJS-$(CONFIG_FFT)                += arm/fft_neon.o                \

NEON-OBJS-$(CONFIG_MDCT)               += arm/mdct_neon.o               \

NEON-OBJS-$(CONFIG_RDFT)               += arm/rdft_neon.o               \

NEON-OBJS-$(CONFIG_H264DSP)            += arm/h264dsp_neon.o            \
                                          arm/h264idct_neon.o           \
                                          arm/h264pred_neon.o           \

NEON-OBJS-$(CONFIG_DCA_DECODER)        += arm/synth_filter_neon.o       \

NEON-OBJS-$(CONFIG_VP3_DECODER)        += arm/vp3dsp_neon.o

OBJS-$(HAVE_NEON)                      += arm/dsputil_init_neon.o       \
                                          arm/dsputil_neon.o            \
                                          arm/int_neon.o                \
                                          arm/simple_idct_neon.o        \
                                          $(NEON-OBJS-yes)

=== plugins/ADM_audioEncoders/CMakeLists.txt ===
#######################################
include (admCheckAudioEncoderLibs)
include (admConfigSummary)

ADD_SUBDIRECTORY(twolame)
ADD_SUBDIRECTORY(pcm)
ADD_SUBDIRECTORY(lavcodec)

if(USE_LAME)
ADD_SUBDIRECTORY(lame)
endif(USE_LAME)

if(USE_AFTEN)
	ADD_SUBDIRECTORY(aften)
endif(USE_AFTEN)

if(USE_VORBIS)
ADD_SUBDIRECTORY(vorbis)
endif(USE_VORBIS)

if(USE_FAAC)
ADD_SUBDIRECTORY(faac)
endif(USE_FAAC)

=== plugins/ADM_videoFilters/CMakeLists.txt ===
ADD_SUBDIRECTORY(AddBorders)
ADD_SUBDIRECTORY(BlendRemover)
ADD_SUBDIRECTORY(Chroma)
ADD_SUBDIRECTORY(Decimate)
ADD_SUBDIRECTORY(DgBob)
ADD_SUBDIRECTORY(Fade)
ADD_SUBDIRECTORY(FastConvolution)
ADD_SUBDIRECTORY(ForcedPP)
ADD_SUBDIRECTORY(LargeMedian)
ADD_SUBDIRECTORY(LumaOnly)
ADD_SUBDIRECTORY(McDeint)
ADD_SUBDIRECTORY(MplayerDenoise3D)
ADD_SUBDIRECTORY(ResampleFps)
ADD_SUBDIRECTORY(Reverse)
ADD_SUBDIRECTORY(SwapUV)
ADD_SUBDIRECTORY(Telecide)
ADD_SUBDIRECTORY(TemporalCleaner)
#ADD_SUBDIRECTORY(Unblend)
ADD_SUBDIRECTORY(VerticalFlip)
ADD_SUBDIRECTORY(Yadif)
ADD_SUBDIRECTORY(Pulldown)
ADD_SUBDIRECTORY(Denoise)
ADD_SUBDIRECTORY(Delta)
ADD_SUBDIRECTORY(DropOut)
ADD_SUBDIRECTORY(AvisynthResize)
ADD_SUBDIRECTORY(MplayerResize)
ADD_SUBDIRECTORY(BlackenBorders)
ADD_SUBDIRECTORY(KernelDeint)
ADD_SUBDIRECTORY(Deinterlace)
ADD_SUBDIRECTORY(KeepField)
ADD_SUBDIRECTORY(FluxSmooth)
ADD_SUBDIRECTORY(Stabilize)
ADD_SUBDIRECTORY(Mosaic)
ADD_SUBDIRECTORY(Whirl)
ADD_SUBDIRECTORY(PalShift)
ADD_SUBDIRECTORY(SwapField)
ADD_SUBDIRECTORY(MSharpen)
ADD_SUBDIRECTORY(MSmooth)
ADD_SUBDIRECTORY(Soften)
ADD_SUBDIRECTORY(lavDeinterlace)
# Dependancy toward codecs ADD_SUBDIRECTORY(Logo)
ADD_SUBDIRECTORY(ChromaShift)
ADD_SUBDIRECTORY(CNR2)
ADD_SUBDIRECTORY(colorYUV)
ADD_SUBDIRECTORY(Equalizer)
ADD_SUBDIRECTORY(MPDelogo)
ADD_SUBDIRECTORY(ASharp)
ADD_SUBDIRECTORY(Contrast)
ADD_SUBDIRECTORY(Eq2)
ADD_SUBDIRECTORY(Hue)
ADD_SUBDIRECTORY(Crop)
ADD_SUBDIRECTORY(Rotate)
ADD_SUBDIRECTORY(Tdeint)
ADD_SUBDIRECTORY(Srt)
ADD_SUBDIRECTORY(Ass)
# Dependancy toward codec & pics ADD_SUBDIRECTORY(Animated)
#ADD_SUBDIRECTORY(leakKernelDeint)
ADD_SUBDIRECTORY(TIsophote)
ADD_SUBDIRECTORY(CurveEditor)

=== avidemux/ADM_core/src/CMakeLists.txt ===
SET(ADM_core_SRCS 
	ADM_cpuCap.cpp  ADM_memcpy.cpp  ADM_memsupport.cpp  ADM_threads.cpp  ADM_win32.cpp
	ADM_memory.cpp  ADM_misc.cpp  TLK_clock.cpp  ADM_crashdump.cpp  ADM_fileio.cpp ADM_dynamicLoading.cpp
)

ADD_LIBRARY(ADM_core SHARED ${ADM_core_SRCS})
ADD_TARGET_DEFINITIONS(ADM_core ADM_DEBUG FIND_LEAKS)

IF (MINGW)
	TARGET_LINK_LIBRARIES(ADM_core "${PTHREAD_LIBRARIES}" imagehlp ws2_32)
	ADD_TARGET_CFLAGS(ADM_core "-I${PTHREAD_INCLUDE_DIR}")
ELSE (MINGW)
	TARGET_LINK_LIBRARIES(ADM_core dl)
	
	IF (APPLE)
		ADD_TARGET_LDFLAGS(ADM_core "-framework Carbon")
	ENDIF (APPLE)
ENDIF (MINGW)

REMOVE_DEFINITIONS(-DHAVE_CONFIG_H)
include_directories("${FFMPEG_BINARY_DIR}")

INSTALL(TARGETS ADM_core RUNTIME DESTINATION ${BIN_DIR}  LIBRARY DESTINATION lib${LIB_SUFFIX}  ARCHIVE DESTINATION lib${LIB_SUFFIX})

=== avidemux/ADM_inputs/ADM_mpegdemuxer/CMakeLists.txt ===
SET(ADM_mpegdemuxer_SRCS 
	dmx_audio.cpp    dmx_demuxerES.cpp     dmx_demuxerPS.cpp  dmx_identify.cpp  dmx_indexer_h264.cpp   dmx_io.cpp     dmx_probeTS.cpp
	dmx_demuxer.cpp  dmx_demuxerMSDVR.cpp  dmx_demuxerTS.cpp  dmx_indexer.cpp   dmx_indexer_mpeg2.cpp  dmx_probe.cpp  dmx_video.cpp)

ADD_ADM_LIB_ALL_TARGETS(ADM_mpegdemuxer ${ADM_mpegdemuxer_SRCS})

=== avidemux/ADM_userInterfaces/ADM_commonUI/CMakeLists.txt ===
SET(ADM_LIB ADM_commonUI)

SET(${ADM_LIB}_SRCS
DIA_v2v.cpp
DIA_audioFilter.cpp   
DIA_gototime.cpp    
DIA_postproc.cpp  
DIA_bitrateHisto.cpp  
DIA_prefs.cpp     
DIA_builtin.cpp       
DIA_lavDecoder.cpp  
DIA_requant.cpp   
DIA_ocr.cpp             
DIA_tsSub.cpp        
DIA_jobs_save.cpp
DIA_plugins.cpp
DIA_muxerMpegPs.cpp
)

ADD_ADM_LIB_ALL_TARGETS(${ADM_LIB} ${${ADM_LIB}_SRCS})

=== plugins/ADM_audioEncoders/aften/CMakeLists.txt ===
	INCLUDE(ae_plugin)

	SET(ADM_ae_aften_SRCS audioencoder_aften.cpp)

	ADD_LIBRARY(ADM_ae_aften SHARED ${ADM_ae_aften_SRCS})

	TARGET_LINK_LIBRARIES(ADM_ae_aften ${AFTEN_LIBRARY_DIR} ADM_core ADM_coreAudio ADM_coreUI)

	ADD_TARGET_CFLAGS(ADM_ae_aften "-I${AFTEN_INCLUDE_DIR}")
        if(USE_AFTEN_08_SVN)
                ADD_DEFINITIONS(-DUSE_AFTEN_08_SVN)
        endif(USE_AFTEN_08_SVN)
        if(USE_AFTEN_08)
                ADD_DEFINITIONS(-DUSE_AFTEN_08)
        endif(USE_AFTEN_08)

	INIT_AUDIO_ENCODER(ADM_ae_aften)
	INSTALL_AUDIOENCODER(ADM_ae_aften)

=== plugins/ADM_audioEncoders/lame/CMakeLists.txt ===
	INCLUDE(ae_plugin)

	SET(ADM_ae_lame_SRCS audioencoder_lame.cpp)

	ADD_LIBRARY(ADM_ae_lame SHARED ${ADM_ae_lame_SRCS})

	TARGET_LINK_LIBRARIES(ADM_ae_lame ${LAME_LIBRARY_DIR} ADM_core ADM_coreAudio ADM_coreUI)

	ADD_TARGET_CFLAGS(ADM_ae_lame "-I${LAME_INCLUDE_DIR}")

	INIT_AUDIO_ENCODER(ADM_ae_lame)
	INSTALL_AUDIOENCODER(ADM_ae_lame)

=== debian/changelog ===
avidemux (1:2.5.3-0ubuntu3) maverick; urgency=low

  * Bump Standards.
  * Add debian/patches/04-xvid-detection.diff for proper xvid detection:
    - Fixes FTBFS on Maverick (LP: #614896).

 -- Артём Попов <artfwo@gmail.com>  Sun, 08 Aug 2010 10:43:33 +0700

avidemux (1:2.5.3-0ubuntu2) maverick; urgency=low

  * Bump Standards.
  * Rebuild for JACK2 transition.
  * Add missing misc:Depends macro to avidemux-common's Depends field.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Wed, 21 Jul 2010 12:58:06 +0200

avidemux (1:2.5.3-0ubuntu1) maverick; urgency=low

  * New upstream release (LP: #577798):
    - Fix crash when importing from DVD iso (LP: #450584).
  * Switch to debian 3.0 (quilt) format to ease upstream's tarball repacking.
  * Remove unnecessary debian/README.source file.
  * debian/control:
    - Don't build-depend on quilt.
    - Build-depend on yasm for i386,amd64 architectures.
    - Bump Standards.
    - Add Vcs-* tags.
  * debian/rules:
    - Remove get-orig-source rule, no longer needed.
    - Don't pass DAVIDEMUX_LIB_DIR=/usr/lib to cmake, otherwise it tries to
      to link plugins against the system libs.
  * debian/avidemux-plugins-common.install: Install
    usr/lib/ADM_plugins/videoEncoder/{libADM_vidEnc_mpeg2enc.so,mpeg2enc/*}.
  * Refresh patches.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Sun, 09 May 2010 19:47:31 +0200

avidemux (1:2.5.2-0ubuntu3) lucid; urgency=low

  * No-change rebuild against libfaad2 (libfaad0 is NBS).

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 08 Mar 2010 16:45:59 +0100

avidemux (1:2.5.2-0ubuntu2) lucid; urgency=low

  * Add missing Conflicts/Replaces on avidemux-plugins to the new plugins
    packages
  * Add debian/patches/03-no-altivec.diff so SET(ADM_CPU_ALTIVEC 1) is not set
    - Attempt to avoid FTBFS on Ubuntu powerpc

 -- Scott Kitterman <scott@kitterman.com>  Sun, 27 Dec 2009 17:15:18 -0500

avidemux (1:2.5.2-0ubuntu1) lucid; urgency=low

  * New upstream release
    - Drop debian/patches/03-fix_crash_with_greek_locale.diff (incorporated
      upstream)
  * Add build-depends on libopencore-amrnb-dev and libopencore-amrwb-dev to
    provide missing codec support
  * Add build-depends on gettext
  * Change arch: any packages to arch: i386 amd64 powerpc
    - These are the only platforms upstream supports see
      cmake/admDetermineSystem.cmake
  * Split avidemux-plugins into avidemux-plugins-common, avidemux-plugins-qt,
    avidemux-plugins-gtk, avidemux-plugins-cli (LP: #454167)
    - Adjust for avidemux, avidemux-qt, and avidemux-cli
  * Move plugins to recommends

 -- Scott Kitterman <scott@kitterman.com>  Sun, 27 Dec 2009 00:05:55 -0500

avidemux (1:2.5.2~rc-0ubuntu3) lucid; urgency=low

  * debian/patches/03-fix_crash_with_greek_locale.diff:
    - Prevent crash while using Greek language (LP: #344528).

 -- Alessio Treglia <quadrispro@ubuntu.com>  Sat, 19 Dec 2009 03:29:35 +0100

avidemux (1:2.5.2~rc-0ubuntu2) lucid; urgency=low

  * Add PulseAudio support (LP: #215560).
  * Append ${misc:Depends} macro to the Depends fields.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Mon, 14 Dec 2009 00:35:23 +0100

avidemux (1:2.5.2~rc-0ubuntu1) lucid; urgency=low

  * 2.5.2 release candidate; taken from upstream's SVN
    (tag avidemux_2.5.2rc, revision #5655):
    - Re-enabled Vorbis decoder (regression introduced 2.5.0)
    - Updated the FFmpeg libraries
    - Added support for latest x264 core and updated Qt interface
    - Added support for H264 video, VP6A video and AAC audio in FLV
      container
    - Added support for SEDG and WMVA four CCs
    - Various fixes related to Xvid settings
    - Fixed Xvid stat files remaining locked after encoding (regression
      introduced 2.5.0)
    - Improved MKV demuxer
    - New Colour Curve Editor plugin for Qt interface
    - Fixed partial filter support (regression introduced 2.5.0)
    - Fixed FluxSmooth filter plugin (regression introduced 2.5.0)
    - Added extra bitrate settings for LAME audio encoder
    - Enabled JACK audio device plugin (regression introduced 2.5.0)
    - Various GUI fixes for GTK+ and Qt interface
    - Fixed command-line interface support for various video filters
    - Changed "save-jpg" parameter of command-line interface to honour
      "begin" parameter
    - Fixed saving of crash file when Avidemux unexpectedly quits (regression
      introduced in 2.5.0)
    - Fixed GUI quirks when using Copy mode and AVI un/packing
    - Proper channel mapping for multichannel DTS & Vorbis files
    - Proper decoding of 5.1 vorbis file in mkv
    - Fixes bugs:
      - LP: #481561
  * debian/rules: Update ffmpeg tarballs' filenames.
  * Drop 01-build_vorbis_decoder.diff patch.
  * Refresh 02-alsa_output.diff patch, partially adopted by upstream.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Sun, 13 Dec 2009 12:41:41 +0100

avidemux (1:2.5.1+repack-0ubuntu3) lucid; urgency=low

  * Add 02-alsa_output.diff to make ALSA uses a different device (LP: #321028)
  * Refresh patches.
  * debian/control: Replace libxvidcore4-dev with libxvidcore-dev.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Mon, 23 Nov 2009 16:59:21 +0100

avidemux (1:2.5.1+repack-0ubuntu2) karmic; urgency=low

  * debian/{control,rules,README.source}: Add quilt support.
  * debian/rules: Prevent FTBFS if the dir exists.
  * Add a patch to build vorbis decoder plugin (LP: #447720).

 -- Alessio Treglia <quadrispro@ubuntu.com>  Mon, 12 Oct 2009 23:44:26 +0200

avidemux (1:2.5.1+repack-0ubuntu1) karmic; urgency=low

  * New upstream bugfix release (LP: #416066):
    - Re-enabled several video and audio encoders (regression introduced
      in 2.5.0)
    - Updated the FFmpeg libraries
    - More video encoders are now plugins
    - DV video encoder now supports more profiles
    - Fixed loading and saving issues with LAME, x264 and Xvid options
      (regression introduced in 2.5.0)
    - Fraps video decoding support
    - Lowpass-5 mode added to libavcodec deinterlacer filter plugin


=== debian/control ===
Source: avidemux
Section: graphics
Priority: optional
Maintainer: Alessio Treglia <quadrispro@ubuntu.com>
Homepage: http://avidemux.org
Standards-Version: 3.9.1
Build-Depends: debhelper (>> 7),
 cmake,
 gettext,
 libgtk2.0-dev,
 libmp3lame-dev,
 libmad0-dev,
 liba52-dev,
 libvorbis-dev,
 libmjpegtools-dev,
 libxvidcore-dev,
 libfreetype6-dev,
 libxml2-dev,
 libasound2-dev,
 libsdl-dev,
 libxv-dev,
 libxmu-dev,
 libfaac-dev (>= 1.24),
 libfaad-dev,
 libx264-dev (>= 1:0.svn20090222),
 libqt4-dev,
 imagemagick,
 libsamplerate0-dev,
 libdca-dev,
 libjack-dev,
 libpulse-dev,
 yasm [i386 amd64],
 libopencore-amrnb-dev,
 libopencore-amrwb-dev
Vcs-Git: git://git.debian.org/collab-maint/avidemux.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/avidemux.git

Package: avidemux
Architecture: i386 amd64 powerpc
Depends: ${shlibs:Depends},
 avidemux-common,
 libavidemux0,
 ${misc:Depends}
Recommends: avidemux-plugins-gtk
Description: a free video editor - GTK version
 Avidemux is a free video editor designed for simple cutting, filtering and
 encoding tasks. It supports many file types, including AVI, DVD compatible
 MPEG files, MP4 and ASF, using a variety of codecs. Tasks can be automated
 using projects, job queue and powerful scripting capabilities.
 .
 This package contains the classic version with GTK+ interface.

Package: avidemux-qt
Architecture: i386 amd64 powerpc
Depends: ${shlibs:Depends},
 avidemux-common,
 libavidemux0,
 ${misc:Depends}
Recommends: avidemux-plugins-qt
Provides: avidemux
Description: a free video editor - QT version
 Avidemux is a free video editor designed for simple cutting, filtering and
 encoding tasks. It supports many file types, including AVI, DVD compatible
 MPEG files, MP4 and ASF, using a variety of codecs. Tasks can be automated
 using projects, job queue and powerful scripting capabilities.
 .
 This package contains the QT4 version.

Package: avidemux-cli
Architecture: i386 amd64 powerpc
Depends: ${shlibs:Depends},
 avidemux-common,
 libavidemux0,
 ${misc:Depends}
Recommends: avidemux-plugins-cli
Provides: avidemux
Description: a free video editor - command line version
 Avidemux is a free video editor designed for simple cutting, filtering and
 encoding tasks. It supports many file types, including AVI, DVD compatible
 MPEG files, MP4 and ASF, using a variety of codecs. Tasks can be automated
 using projects, job queue and powerful scripting capabilities.
 .
 This package contains the command line version.

Package: avidemux-common
Architecture: all
Depends: ${misc:Depends}
Replaces: avidemux (<= 1:2.4.0-0.0)
Description: a free video editor - Internationalization files
 Avidemux is a free video editor designed for simple cutting, filtering and
 encoding tasks. It supports many file types, including AVI, DVD compatible
 MPEG files, MP4 and ASF, using a variety of codecs. Tasks can be automated
 using projects, job queue and powerful scripting capabilities.
 .
 This package contains internationalization files needed to translate
 strings in avidemux to others languages.

Package: avidemux-plugins-common
Architecture: i386 amd64 powerpc
Depends: ${shlibs:Depends},
 ${misc:Depends}
Conflicts: avidemux-plugins
Replaces: avidemux-plugins
Description: a free video editor - common files for plugins
 Avidemux is a free video editor designed for simple cutting, filtering and
 encoding tasks. It supports many file types, including AVI, DVD compatible
 MPEG files, MP4 and ASF, using a variety of codecs. Tasks can be automated
 using projects, job queue and powerful scripting capabilities.
 .
 This package includes common files for plugins to extend the functionality
 of Avidemux and should not be installed directly.

Package: avidemux-plugins-gtk
Architecture: i386 amd64 powerpc
Depends: avidemux-plugins-common,
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: avidemux-plugins
Replaces: avidemux-plugins
Description: a free video editor - GTK plugins
 Avidemux is a free video editor designed for simple cutting, filtering and
 encoding tasks. It supports many file types, including AVI, DVD compatible
 MPEG files, MP4 and ASF, using a variety of codecs. Tasks can be automated
 using projects, job queue and powerful scripting capabilities.
 .
 This package includes plugins to extend the functionality of Avidemux.

Package: avidemux-plugins-qt
Architecture: i386 amd64 powerpc
Depends: avidemux-plugins-common,
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: avidemux-plugins
Replaces: avidemux-plugins
Description: a free video editor - Qt plugins
 Avidemux is a free video editor designed for simple cutting, filtering and
 encoding tasks. It supports many file types, including AVI, DVD compatible
 MPEG files, MP4 and ASF, using a variety of codecs. Tasks can be automated
 using projects, job queue and powerful scripting capabilities.
 .
 This package includes plugins to extend the functionality of Avidemux Qt.

Package: avidemux-plugins-cli
Architecture: i386 amd64 powerpc
Depends: avidemux-plugins-common,
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: avidemux-plugins
Replaces: avidemux-plugins
Description: a free video editor - CLI plugins
 Avidemux is a free video editor designed for simple cutting, filtering and
 encoding tasks. It supports many file types, including AVI, DVD compatible
 MPEG files, MP4 and ASF, using a variety of codecs. Tasks can be automated
 using projects, job queue and powerful scripting capabilities.
 .
 This package includes plugins to extend the functionality of Avidemux CLI.

Package: libavidemux0
Architecture: i386 amd64 powerpc
Depends: ${shlibs:Depends},
 ${misc:Depends}
Replaces: avidemux (<= 1:2.5.0-0.0ubuntu3)
Recommends: mjpegtools, twolame, lame
Description: a free video editor - shared libraries
 Avidemux is a free video editor designed for simple cutting, filtering and
 encoding tasks. It supports many file types, including AVI, DVD compatible
 MPEG files, MP4 and ASF, using a variety of codecs. Tasks can be automated
 using projects, job queue and powerful scripting capabilities.
 .
 This package contains the shared library files.

=== debian/rules ===
#!/usr/bin/make -f

configure: configure-stamp
configure-stamp:
	dh_testdir

	mkdir -p build/avidemux/ADM_libraries
	cp avidemux/ADM_libraries/ffmpeg_r22831.tar.gz build/avidemux/ADM_libraries
	cp avidemux/ADM_libraries/libswscale_r31028.tar.gz build/avidemux/ADM_libraries

	cd build && cmake .. \
		-DCMAKE_INSTALL_PREFIX:PATH=/usr -DCMAKE_SKIP_RPATH:BOOL=YES

	touch $@

build: build-stamp
build-stamp: configure-stamp
	dh_testdir

	cd build && $(MAKE) ffmpeg
	cd build && $(MAKE)

	# all libraries are linked in a special directory
	# to build the plugins. See this thread for details:
	# http://bbs.archlinux.org/viewtopic.php?id=75446
	cd $(CURDIR)/build/ && \
	mkdir -p lib && cd lib && \
	find ../avidemux -name '*.so*' | xargs ln -sft .

	# now build the plugins.
	cd $(CURDIR)/plugins/ && \
	mkdir -p build && \
	cd build && \
	cmake -DAVIDEMUX_SOURCE_DIR=$(CURDIR) \
	-DAVIDEMUX_CORECONFIG_DIR=$(CURDIR)/build/config \
	-DAVIDEMUX_INSTALL_PREFIX=$(CURDIR)/build/ \
	-DCMAKE_INSTALL_PREFIX:PATH=/usr .. && \
	$(MAKE)

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	rm -rf build plugins/build
	rm -rf CMakeFiles
	rm -rf avidemux/ADM_libraries/ffmpeg

	dh_clean client_state.xml

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	cd build && $(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

	rm -rf debian/tmp/usr/bin/i18n

	for i in 16 22 24 32 36 48; do \
	    mkdir -p debian/tmp/usr/share/icons/hicolor/$${i}x$${i}/apps || exit 1; \
	    convert avidemux_icon.png -resize $$i \
	    debian/tmp/usr/share/icons/hicolor/$${i}x$${i}/apps/avidemux.png || exit 1; \
	done

	# now install the plugins.
	cd $(CURDIR)/plugins/build/ && \
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

	dh_install --fail-missing

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i
	dh_installchangelogs -i
	dh_installman -i
	dh_icons -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installdocs -a
	dh_installmenu -a
	dh_installchangelogs -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -a -V
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
